import { hideNoticeBindTweet } from "@/logic/content/twitter.js"

import { hidePinTips } from '@/logic/content/pinTips.js'

let showPopupPageFrom = '';

export const setPopupConfByPopupPage = () => {
    let iframe = document.getElementById('de-popup-page');
    if (iframe) {
        let { transform = '' } = iframe.style;

        if (transform && transform == 'translateX(-395px)') {
            chrome.runtime.sendMessage({
                actionType: "CONTENT_SET_POPUP_CONFIG",
                data: {
                    popup: ''
                }
            }, () => { });
        } else {
            chrome.runtime.sendMessage({
                actionType: "CONTENT_SET_POPUP_CONFIG",
                data: {
                    popup: 'popup.html'
                }
            }, () => { });
        }
    } else {
        chrome.runtime.sendMessage({
            actionType: "CONTENT_SET_POPUP_CONFIG",
            data: {
                popup: 'popup.html'
            }
        }, () => { });
    }
}

export const tiggerInjectPopupPage = () => {
    let iframeContent = document.getElementById('de-popup-page');
    if (iframeContent) {
        hidePinTips();
        hideNoticeBindTweet();
        let { transform = '' } = iframeContent.style;
        if (transform == 'translateX(385px)' || !transform) {
            showPopupPage();
        } else {
            hidePopupPage();
        }
    } else {
        appendPopupPage();
        setTimeout(() => {
            let iframe = document.getElementById('de-popup-page');
            let { transform = '' } = iframe.style;
            if (transform == 'translateX(385px)' || !transform) {
                showPopupPage();
            } else {
                hidePopupPage();
            }
        }, 300)
    }
}


export const appendPopupPage = (params = {}) => {
    let { path = '' } = params;

    let iframe = document.createElement('iframe');
    iframe.id = 'de-popup-page';
    iframe.src = chrome.runtime.getURL('/iframe/popup-page.html') + `#${path}`;
    iframe.style.cssText = `border: medium none; width: 375px !important;
        height: 650px;position: fixed; right: 16px; top: 16px;background: #FFFFFF;border: 0.5px solid #919191;box-shadow: 0px 4px 20px rgba(0, 0, 0, 0.2);box-sizing: border-box;z-index: 90000;
        animation-duration: 0.5s !important;
        animation-timing-function: ease-in-out !important;
        animation-fill-mode: forwards !important;
        transition: all 1s ease 0s !important;right: -385px;transform: translateX(385px);`
    let iframeContent = document.getElementById('de-popup-page');

    let overlayDom = document.createElement('div');
    overlayDom.id = 'de-popup-overlay';
    overlayDom.style.cssText = `position: fixed;z-index: 88888;top: 0;
        left: 0;width: 100%;height: 100%;opacity: 0;display: none`;

    let overlay = document.getElementById('de-popup-overlay');
    let body = document.querySelector('body');

    if (!iframeContent && body) {
        document.querySelector('body').appendChild(iframe);
        if (!overlay) {
            document.querySelector('body').appendChild(overlayDom);

            overlayDom.addEventListener('click', function () {
                hidePopupPage();
            })
        } else {
            overlay.addEventListener('click', function () {
                hidePopupPage();
            })
        }
    }
}

export const hidePopupPage = () => {
    let iframe = document.getElementById('de-popup-page');
    if (iframe) {
        iframe.style.transform = 'translateX(' + 385 + 'px)';

        let overlay = document.getElementById('de-popup-overlay');
        overlay.style.display = 'none';

        let htmlDom = document.querySelector('html');
        if (htmlDom) {
            htmlDom.style.overflowY = 'auto';
        }

        chrome.runtime.sendMessage({
            actionType: "CONTENT_SET_POPUP_CONFIG",
            data: {
                popup: 'popup.html'
            }
        }, () => { });

        if (showPopupPageFrom == 'BUY_NFT_FINISH') {
            chrome.runtime.sendMessage({
                actionType: "CONTENT_GET_PINED",
                data: {}
            }, () => { });
            showPopupPageFrom = '';
        }
    }
}

export const showPopupPage = (params = {}) => {
    let { path = '', from, showJoinGroupFinish = false } = params;
    showPopupPageFrom = from;
    hidePinTips();
    hideNoticeBindTweet();

    let iframe = document.getElementById('de-popup-page');
    if (!iframe) {
        appendPopupPage();
        iframe = document.getElementById('de-popup-page');
    }
    if (iframe) {
        if (path) {
            iframe.src = chrome.runtime.getURL('/iframe/popup-page.html') + `#${path}`;
        }
        iframe.style.transform = 'translateX(-' + 395 + 'px)';

        chrome.runtime.sendMessage({
            actionType: "CONTENT_POPUP_PAGE_SHOW",
            data: {
                path,
                showJoinGroupFinish,
            }
        }, () => { });

        chrome.runtime.sendMessage({
            actionType: "CONTENT_SET_POPUP_CONFIG",
            data: {
                popup: ''
            }
        }, () => { });

        let overlay = document.getElementById('de-popup-overlay');
        overlay.style.display = 'block';

        let htmlDom = document.querySelector('html');
        if (htmlDom) {
            htmlDom.style.overflowY = 'hidden';
        }
    }
}